Option Strict Off 'sorry! 
'but 'Option Strict On Disallows Late Binding

Imports Microsoft.Office.Core
imports Extensibility
imports System.Runtime.InteropServices
Imports EnvDTE

Imports CodeGenSample

#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the ExecInlineSetup project 
' by right clicking the project in the Solution Explorer, then choosing install.
#End Region

<GuidAttribute("C85BD15B-B720-47C3-BFFB-1B2586011B9F"), ProgIdAttribute("ExecInline.Connect")> _
Public Class Connect
	
	Implements Extensibility.IDTExtensibility2
	Implements IDTCommandTarget
	
    Dim _applicationObject As EnvDTE.DTE
    Dim _addInInstance As EnvDTE.AddIn

	Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown
	End Sub
	
	Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
	End Sub
	
	Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete
	End Sub
	
    Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection


    End Sub

    Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection

        _applicationObject = CType(application, EnvDTE.DTE)
        _addInInstance = CType(addInInst, EnvDTE.AddIn)

        If connectMode = ext_ConnectMode.ext_cm_UISetup Or connectMode = ext_ConnectMode.ext_cm_AfterStartup Or connectMode = ext_ConnectMode.ext_cm_Startup Then

            Dim commands As Commands = CType( _
                _applicationObject.Commands, Commands)
            Dim editMenuName As String

            Try
                Dim resourceManager As System.Resources.ResourceManager = _
                    New System.Resources.ResourceManager( _
                        "ExecInline.CommandBar", _
                        System.Reflection.Assembly.GetExecutingAssembly())

                Dim cultureInfo As System.Globalization.CultureInfo = _
                    New System.Globalization.CultureInfo( _
                        _applicationObject.LocaleID)
                editMenuName = resourceManager.GetString( _
                    String.Concat(cultureInfo.TwoLetterISOLanguageName, _
                        "Edit"))

            Catch e As Exception
                editMenuName = "Edit"
            End Try

            Dim commandBars As CommandBars = _
                CType(_applicationObject.CommandBars, CommandBars)
            Dim menuBarCommandBar As CommandBar = commandBars.Item("MenuBar")

            Dim editControl As CommandBarControl = _
                menuBarCommandBar.Controls.Item(editMenuName)
            Dim editPopup As CommandBarPopup = CType(editControl, CommandBarPopup)

            Try
                Dim command As Command = commands.AddNamedCommand( _
                    _addInInstance, "ExecInline", "Execute Selected Code", _
                    "Exec the selected text immediately", True, 343, Nothing, _
                    CType(vsCommandStatus.vsCommandStatusSupported, Integer) + _
                    CType(vsCommandStatus.vsCommandStatusEnabled, Integer))
                'The number 343 is a kind of lightbulb, i hope.
                'originally i used 59, which is a little smiley face (used by
                'lots of sample plug ins)


                command.AddControl(editPopup.CommandBar, 12)
            Catch argumentException As System.ArgumentException
            End Try

        End If


    End Sub

    'Default of 4 -- but the user settings will be used
    Dim m_indentSize As Integer = 4

    Public Sub Exec(ByVal cmdName As String, ByVal executeOption As vsCommandExecOption, ByRef varIn As Object, ByRef varOut As Object, ByRef handled As Boolean) Implements IDTCommandTarget.Exec
        handled = False
        If (executeOption = vsCommandExecOption.vsCommandExecOptionDoDefault) Then
            If cmdName = "ExecInline.Connect.ExecInline" Then
                Try
                    Select Case _applicationObject.ActiveDocument.Language
                        Case "Basic"
                            m_language = CompileEngine.languagetype.vb

                        Case Else
                            m_language = CompileEngine.languagetype.csharp
                    End Select
                    m_indentSize = _applicationObject.ActiveDocument.IndentSize

                    Go(_applicationObject.ActiveDocument.Selection.Text)
                Catch ex As Exception
                    ImmediateCodeGenUI.ShowMessage(String.Concat( _
                      "Sorry, Immediate Execution failed badly", vbCrLf, _
                      "Input:", vbCrLf, _
                      _applicationObject.ActiveDocument.Selection.Text, vbCrLf, _
                      "Error:", vbCrLf, ex), _
                      "Big Trouble in Little China")
                End Try
                handled = True
                Exit Sub
            End If
        End If
    End Sub

    Public Sub QueryStatus(ByVal cmdName As String, ByVal neededText As vsCommandStatusTextWanted, ByRef statusOption As vsCommandStatus, ByRef commandText As Object) Implements IDTCommandTarget.QueryStatus
        If neededText = EnvDTE.vsCommandStatusTextWanted.vsCommandStatusTextWantedNone Then
            If cmdName = "ExecInline.Connect.ExecInline" Then
                statusOption = CType(vsCommandStatus.vsCommandStatusEnabled + vsCommandStatus.vsCommandStatusSupported, vsCommandStatus)
            Else
                statusOption = vsCommandStatus.vsCommandStatusUnsupported
            End If
        End If
    End Sub

    Dim m_Code As String
    Dim m_language As CompileEngine.languagetype = CompileEngine.languagetype.vb

    Private Sub Go(ByVal code As String)
        m_Code = code
        'Couldn't be bothered passing parameter to the new method
        'so i'm using class level variables to communicate with it...
        'go on, sue me.
        Dim t As New Threading.Thread(AddressOf RunTheProg)
        t.Start()

    End Sub


    Private Sub RunTheProg()
        'by this stage the m_language variable is set
        'as is the m_code variable.

        Dim code As String = m_Code
        Dim entry As String
        If (code = "") Then Return
        If (entry = "") Then entry = "Main"
        Dim engine As CompileEngine = New CompileEngine(code, m_language, entry)
        Dim errors As Object() = engine.Run()
        If Not errors Is Nothing Or Not engine.Exception Is Nothing Then
            ImmediateCodeGenUI.ShowMessage(engine.sourceCode, errors, engine.Exception, m_language)
        End If
    End Sub


End Class
